/*****************************************************************************/
/*      EQUINOX SuperSerial Technology (SST) Driver for Linux                */
/*                                                                           */
/*      Copyright (C) 1989-2002 Equinox Systems Inc.                         */
/*****************************************************************************/   

#define PCI_CSH_LEN 0x40

struct pci_csh00 { /* Type 00 Configuration Space Header */
	unsigned short vend_id;
	unsigned short dev_id;
	unsigned short command;
	unsigned short status;
	unsigned char  rev_id;
	unsigned char  prog_if;
	unsigned char  sub_class;
	unsigned char  class;
	unsigned char  cache_line_size;
	unsigned char  latency_timer;
	unsigned char  header_type;
	unsigned char  bist;              /* built in self timer */
	paddr_t        base_addr_reg0;
	paddr_t        base_addr_reg1;
	paddr_t        base_addr_reg2;
	paddr_t        base_addr_reg3;
	paddr_t        base_addr_reg4;
	paddr_t        base_addr_reg5;
	unsigned int   cisp;          /* Cardbus Info Struct pointer (PCMCIA) */
	unsigned short sub_sys_vend_id;
	unsigned short sub_sys_id;
	paddr_t        rom_base_addr;
	unsigned int   res1;
	unsigned int   res2;
	unsigned char  interrupt_line;
	unsigned char  interrupt_pin;
	unsigned char  min_gnt;       /* len of burst period @ 33MHz */
	unsigned char max_lat;        /* freq. of PCI bus access */
} ;

struct pci_csh {  /* Generic Configuration Space Header */
	union {
		unsigned int     vl[PCI_CSH_LEN/sizeof(int)];
		unsigned short   vs[PCI_CSH_LEN/sizeof(short)];
		unsigned char    vc[PCI_CSH_LEN];
		struct pci_csh00 csh00;
	} cs;
	unsigned char bus;
	unsigned char slot;
} ;
