/*****************************************************************************/
/*      EQUINOX SuperSerial Technology (SST) Driver for Linux                */
/*                                                                           */
/*      Copyright (C) 1989-2002 Equinox Systems Inc.                         */
/*****************************************************************************/   

/*#title EQUINOX CONFIDENTIAL - Header File Defining The Register Layout Of The ICP#*/
/**************************************/
/*                                    */
/*    ICP C LANGUAGE  HEADER FILE     */
/*                                    */
/*                FOR                 */
/*                                    */
/*       ISA BUS IMPLEMENTATION       */
/*                                    */
/*                                    */
/*          FILE:   RAMP_ICP.H        */
/*          DATE:   05/23/96          */
/*           REV:    10               */
/*                                    */
/* NOTE: Re-named copy of ICP.H due   */
/*	 naming conflict with DRIVERS */
/**************************************/

#define	RAMP_ICP_H_INCLUDED		/*Create Symbol indicating RAMP_ICP.H 	*/
					/*already included/compiled		*/

/******************************************************************************/
/*                                                                            */
/* NOTE:  !!!!   FOR DETAILS CONCERNING EACH REGISTER REFER TO ASSEMBLY       */
/*	  !!!!   LANGUAGE HEADER FILE "ICP.INC"				      */
/*                                                                            */
/******************************************************************************/
/*#stitle Global Register Definitions#*/
/*#page*/
/**************************************************************************************/
/*                                                                                    */
/*                        GLOBAL REGISTER DEFINITIONS                                 */
/*                                                                                    */
/**************************************************************************************/
struct  icp_global_struct       {

  unsigned char         	global_undefined_1 [24];
  unsigned char         gicp_bus_cntrl;                         /* BUS CONTROL REGISTER 		*/   /* 0018 */
  unsigned char         gicp_rev;                               /* ICP REVISION NUMBER 			*/   /* 0019 */
  unsigned char         	global_undefined_2;
  unsigned char         	global_undefined_3;
  unsigned char         gicp_initiate;                          /* LMX CONTROL & ICP ENABLE 		*/   /* 001C */
  unsigned char         gicp_scan_spd;                          /* LMX SCAN SPEEDS 			*/   /* 001D */
  unsigned char         gicp_tmr_size;                          /* INTERVAL TIMER TICK SIZE PRESET	*/   /* 001E */
  unsigned char         gicp_tmr_count;                         /* INTERVAL TIMER NUMBER OF TICKS PRESET*/   /* 001F */
  unsigned char         	global_undefined_4 [24];
  unsigned char         gicp_watchdog;                          /* WATCHDOG TIMER 			*/   /* 0038 */
  unsigned char         	global_undefined_5;
  unsigned char         	global_undefined_6;
  unsigned char         	global_undefined_7;
  unsigned char         gicp_attn;                              /* GLOBAL STATUS - POLL FOR WORK 	*/   /* 003C */
  unsigned char         gicp_chan;                              /* CURRENT CHANNEL NUMBER 		*/   /* 003D */
  unsigned short        gicp_frame_ctr;                         /* FRAME COUNT				*/   /* 003E */
  unsigned char         	global_undefined_8 [24];
  unsigned char         gicp_rcv_attn [8];                      /* RECEIVE ATTENTION BITS 		*/   /* 0058 */
  unsigned char         	global_undefined_9 [24];
  unsigned char         gicp_xmit_attn [8];                     /* TRANSMIT ATTENTION BITS 		*/   /* 0078 */


};      /* END OF STRUCTURE DEFINING ICP'S GLOBAL REGISTERS */						     /* 0080 */





/*#stitle Input Register Definition, Banked Registers#*/
/*#page*/
/******************************************************************************/
/*                                                                            */
/*                    BANKED REGISTERS DEFINITION		              */
/*                                                                            */
/******************************************************************************/
struct  cin_bank_struct         {

  unsigned short        cin_bank_nxt_dma;                       /* DISPLACEMENT TO NEXT INPUT CHAR DMA 	*/   /* 0000 */
  unsigned char         cin_bank_fifo_lvl;                      /* NUMBER OF CHARACTERS HELD IN FIFO 	*/   /* 0002 */
  unsigned char         cin_bank_tags_l;                        /* INPUT TAGS, LOW BYTE 		*/   /* 0003 */
  unsigned short        cin_bank_signals;                       /* CHANNEL INPUT SIGNALS 		*/   /* 0004 */
  unsigned char         	bank_undefined_1;							     /* 0006 */
  unsigned char         cin_bank_tags_h;                      	/* INPUT TAGS, HIGH BYTE 		*/   /* 0007 */
  unsigned char         cin_bank_chars_0;                     	/* INPUT CHAR FIFO ("OLDEST" CHARACTER)	*/   /* 0008 */
  unsigned char         cin_bank_chars_1;                                                                    /* 0009 */
  unsigned char         cin_bank_chars_2;                                                                    /* 000A */
  unsigned char         cin_bank_chars_3;                                                                    /* 000B */
  unsigned char         cin_bank_chars_4;                                                                    /* 000C */
  unsigned char         cin_bank_chars_5;                                                                    /* 000D */
  unsigned char         cin_bank_chars_6;                                                                    /* 000E */
  unsigned char         cin_bank_chars_7;                                                                    /* 000F */
  unsigned short        cin_bank_num_chars;                     /* NUMBER OF CHARACTERS RECEIVED 	*/   /* 0010 */
  unsigned short        cin_bank_events;                        /* INPUT EVENTS 			*/   /* 0012 */


};      /* END OF STRUCT DEF'G ICP'S INPUT CHAN BANKED REGS */						     /* 0014 */


/*#stitle Input Register Definition#*/
/*#page*/
/******************************************************************************/
/*                                                                            */
/*			INPUT REGISTER DEFINITION                             */
/*                                                                            */
/******************************************************************************/
struct  cin_struct      {

  unsigned short        cin_char_cntrl;                         /* INPUT CHARACTER CONTROL & ATTRIBUTES	*/   /* 0000 */
  unsigned char         cin_locks;                              /* INPUT LOCKS 				*/   /* 0002 */
  unsigned char         cin_dma_hi;                             /* INPUT DMA BASE ADDRESS (HIGH BYTE)	*/   /* 0003 */
  unsigned short        cin_baud;                               /* INPUT BAUD RATE 			*/   /* 0004 */
  unsigned char         cin_q_cntrl;                            /* INPUT QUEUE CONTROL REGISTER 	*/   /* 0006 */
  unsigned char         cin_lit_nxt_char;                       /* LITERAL NEXT CHARACTER 		*/   /* 0007 */
  unsigned char         cin_xon_1;                              /* XON-1 CHARACTER 			*/   /* 0008 */
  unsigned char         cin_xon_2;                              /* XON-2 CHARACTER 			*/   /* 0009 */
  unsigned char         cin_xoff_1;                         	/* XOFF-1 CHARACTER 			*/   /* 000A */
  unsigned char         cin_xoff_2;                         	/* XOFF-2 CHARACTER 			*/   /* 000B */
  unsigned char         	input_undefined_1;	        					     /* 000C */
  unsigned char         	input_undefined_2;	        					     /* 000D */
  unsigned char         	input_undefined_3;							     /* 000E */
  unsigned char         	input_undefined_4;							     /* 000F */
  unsigned char         cin_tmr_preset_sz;                  	/* CHARACTER TIMER SCALE PRESET 	*/   /* 0010 */
  unsigned char         cin_tmr_preset_count;           	/* CHARACTER TIMER # TICKS PRESET 	*/   /* 0011 */
  unsigned short        cin_attn_ena;                           /* INPUT ATTENTION ENABLE 		*/   /* 0012 */
  unsigned short        cin_over_load_lvl;                      /* INPUT QUEUE/BUFFER OVERLOAD LEVEL 	*/   /* 0014 */
  unsigned char         cin_susp_output_lmx;                    /* ENABLE CHAN OUTPUT SUSPENSION  	*/   /* 0016 */
  unsigned char         cin_susp_output_sig;                    /* ENABLE CHAN OUTPUT SUSPENSION 	*/   /* 0017 */
  unsigned short        cin_min_char_lvl;                       /* MINIMUM CHARACTER LEVEL 		*/   /* 0018 */
  unsigned char         	input_undefined_5;							     /* 001A */
  unsigned char         	input_undefined_6;							     /* 001B */
  unsigned char         	input_undefined_7;							     /* 001C */
  unsigned char         	input_undefined_8;							     /* 001D */
  unsigned char         	input_undefined_9;							     /* 001E */
  unsigned char         	input_undefined_10;							     /* 001F */
  unsigned char         cin_lookup_tbl [32];                    /* CHARACTER LOOKUP TABLE 		*/   /* 0020 */
  unsigned short        cin_tail_ptr_a;                         /* TAIL POINTER A 			*/   /* 0040 */
  unsigned char         	input_undefined_11;							     /* 0042 */
  unsigned char         	input_undefined_12;							     /* 0043 */
  struct cin_bank_struct  cin_bank_a;               		/* BASE OF BANK A     			*/   /* 0044 */
  unsigned short        cin_tdm_early;                          /* INPUT TDM EARLY 			*/   /* 0058 */
  unsigned char         	input_undefined_13;							     /* 005A */
  unsigned char         	input_undefined_14;							     /* 005B */
  unsigned short        cin_baud_ctr;                           /* AUTO BAUD COUNTER & CENTER BIT SAMPLING*/ /* 005C */
  unsigned char         cin_input_state;                        /* INPUT STATE 				*/   /* 005E */
  unsigned char         cin_intern_flgs;			/* ICP INTERNAL/SELF-CLEARING FLAGS	*/   /* 005F */
  unsigned short        cin_tail_ptr_b;                         /* TAIL POINTER B 			*/   /* 0060 */
  unsigned char         	input_undefined_15;							     /* 0062 */
  unsigned char         	input_undefined_16;							     /* 0063 */
  struct cin_bank_struct  cin_bank_b;               		/* BASE OF BANKS  B     		*/   /* 0064 */
  unsigned short        cin_tdm_late;                           /* INPUT TDM LATE 			*/   /* 0078 */
  unsigned char         	input_undefined_17;							     /* 007A */
  unsigned char         	input_undefined_18;							     /* 007B */
  unsigned char         cin_tmr_size;                           /* CHARACTER TIMER SCALE 		*/   /* 007C */
  unsigned char         cin_char_tmr_remain;                    /* NUMBER OF REMAINING TICKS 		*/   /* 007D */
  unsigned char         cin_partial_char;                       /* PARTIAL INCOMING CHARACTER 		*/   /* 007E */
  unsigned char         cin_iband_flow_cntrl;                   /* INBAND FLOW CONTROL 			*/   /* 007F */

};      /* END OF STRUCTURE DEFINING ICP'S INPUT REGISTERS */						     /* 0080 */


/*#stitle Output Register Definitions, Queue Registers#*/
/*#page*/
/******************************************************************************/
/*                                                                            */
/*                    	     OUTPUT QUEUE REGISTER DEFINITION                 */
/*                                                                            */
/******************************************************************************/

struct  cout_queue_struct       {

  unsigned short        cout_q_cmnd_ptr_l;                      /* QUEUE COMMAND POINTER:LOWER 16 BITS	*/   /* 0000 */
  unsigned char         cout_q_cmnd_ptr_u;                      /* QUEUE COMMAND POINTER:UPPER 8 BITS 	*/   /* 0002 */
  unsigned char         cout_q_cmd_save;                        /* QUEUE COMMAND SAVE REGISTER 		*/   /* 0003 */
  unsigned short        cout_q_data_ptr_l;                      /* QUEUE DATA POINTER:LOWER 16 BITS 	*/   /* 0004 */
  unsigned char         cout_q_data_ptr_u;                      /* QUEUE DATA POINTER:UPPER 8 BITS 	*/   /* 0006 */
  unsigned char         cout_q_data_q_type;			/* DATA QUEUE/BUFFER TYPE & SIZE	*/   /* 0007 */
  unsigned short        cout_q_data_count;                      /* QUEUE DATA COUNT REGISTER 		*/   /* 0008 */
  unsigned char         cout_q_block_count;                     /* QUEUE BLOCK COUNT REGISTER 		*/   /* 000A */
  unsigned char         cout_q_out_state;                       /* QUEUE OUTPUT STATE REGISTER 		*/   /* 000B */

};      /* END OF STRUCT DEFINING ICP'S O/P QUEUES */							     /* 000C */









/*#stitle Output Register Definitions, Channel Registers#*/
/*#page*/
/******************************************************************************/
/*                                                                            */
/*			OUTPUT REGISTER DEFINITION                            */
/*                                                                            */
/******************************************************************************/

struct  cout_struct     {

  struct cout_queue_struct cout_q0;                        	/* QUEUE ZERO 				*/   /* 0000 */
  unsigned short        cout_tdm_0;                             /* OUTPUT TDM 0 			*/   /* 000C */
  unsigned short        cout_tdm_1;                             /* OUTPUT TDM 1 			*/   /* 000E */
  unsigned char         cout_tx_fifo_0;                         /* TX FIFO BYTE 0 			*/   /* 0010 */
  unsigned char         cout_tx_fifo_1;                         /* TX FIFO BYTE 1 			*/   /* 0011 */
  unsigned char         cout_tx_fifo_2;                         /* TX FIFO BYTE 2 			*/   /* 0012 */
  unsigned char         cout_tx_fifo_3;                         /* TX FIFO BYTE 3 			*/   /* 0013 */
  unsigned char         cout_ses_col_a ;                        /* SESSION COLUMN COUNTER  		*/   /* 0014 */
  unsigned char         cout_ses_cntrl_a;                       /* SESSION CONTROL REGISTER 		*/   /* 0015 */
  unsigned short	cout_ses_char_ctr_a ;			/* SESSION CHARACTER COUNTER		*/   /* 0016 */
  unsigned int		output_undefined_2;             	/* UNDEFINED DWORD 			*/   /* 0018 */
  unsigned int		output_undefined_3;             	/* UNDEFINED DWORD 			*/   /* 001C */
  unsigned char         cout_intnl_flow_ctrl;     		/* INTERNAL FLOW CONTROL STATE		*/   /* 0020 */
  unsigned char  	cout_intnl_opost;			/* INTERNAL OPOST & FLOW CONTROL TIMING	*/   /* 0021 */
  unsigned char  	cout_intnl_fifo_ptrs;			/* INTERNAL FIFO POINTERS		*/   /* 0022 */
  unsigned char  	cout_intnl_svd_toggls;			/* INTERNAL REQUEST & STATE MANAGEMENT	*/   /* 0023 */
  unsigned short        cout_timer;                             /* OUTPUT TIMER 			*/   /* 0024 */
  unsigned short        cout_flow_count;                        /* OUTPUT FLOW CONTROL COUNTER 		*/   /* 0026 */
  unsigned short        cout_cmd_dly_timer;                     /* COMMAND DELAY TIMER 			*/   /* 0028 */
  unsigned short        cout_events_a;                          /* OUTPUT EVENTS REGISTER 		*/   /* 002A */
  unsigned short        cout_status;                            /* OUTPUT STATUS REGISTER 		*/   /* 002C */
  unsigned short        cout_events_b;                          /* OUTPUT EVENTS REGISTER 		*/   /* 002E */
  unsigned short        cout_dma_lower;                         /* CURRENT DMA ADDRESS PNTER: LOW 16 BITS*/  /* 0030 */
  unsigned char         cout_dma_upper;                         /* CURRENT DMA ADDRESS PNTER: UP 8 BITS	*/   /* 0032 */
  unsigned char         cout_dma_stat_save;                     /* DMA STATUS SAVE 			*/   /* 0033 */
  unsigned char         cout_ses_col_b ;                        /* SESSION COLUMN COUNTER  		*/   /* 0034 */
  unsigned char         cout_ses_cntrl_b;                       /* SESSION CONTROL REGISTER 		*/   /* 0035 */
  unsigned short	cout_ses_char_ctr_b ;			/* SESSION CHARACTER COUNTER		*/   /* 0036 */
  unsigned int		output_undefined_6;             	/* UNDEFINED DWORD 			*/   /* 0038 */
  unsigned int		output_undefined_7;             	/* UNDEFINED DWORD 			*/   /* 003C */
  struct cout_queue_struct cout_q1;                        	/* QUEUE ONE 				*/   /* 0040 */
  unsigned short	cout_intnl_baud_ctr;			/* INTERNAL BAUD RATE COUNTER		*/   /* 004C */
  unsigned short	cout_intnl_state;			/* CURRENT OUTPUT CHARACTER STATE	*/   /* 004E */
  unsigned char         cout_tx_fifo_4;                         /* TX FIFO BYTE 4 			*/   /* 0050 */
  unsigned char         cout_tx_fifo_5;                         /* TX FIFO BYTE 5 			*/   /* 0051 */
  unsigned char         cout_tx_fifo_6;                         /* TX FIFO BYTE 6 			*/   /* 0052 */
  unsigned char         cout_tx_fifo_7;                         /* TX FIFO BYTE 7 			*/   /* 0053 */
  unsigned char         cout_ses_col_c ;                        /* SESSION COLUMN COUNTER  		*/   /* 0054 */
  unsigned char         cout_ses_cntrl_c;                       /* SESSION CONTROL REGISTER 		*/   /* 0055 */
  unsigned short	cout_ses_char_ctr_c ;			/* SESSION CHARACTER COUNTER		*/   /* 0056 */
  unsigned int		output_undefined_9;             	/* UNDEFINED DWORD 			*/   /* 0058 */
  unsigned int		output_undefined_10;            	/* UNDEFINED DWORD 			*/   /* 005C */
  unsigned short        cout_baud_rate;                         /* OUTPUT BAUD RATE REGISTER 		*/   /* 0060 */
  unsigned char         cout_char_fmt;                          /* OUTPUT CHARACTER FORMAT REGISTER 	*/   /* 0062 */
  unsigned char         cout_flow_config;                      	/* XON/XOFF CONFIGURATION    		*/   /* 0063 */
  unsigned short        cout_cntrl_sig;                         /* OUTPUT CONTROL SIGNALS 		*/   /* 0064 */
  unsigned char         cout_lmx_command;                       /* LMX COMMAND REGISTER 		*/   /* 0066 */
  unsigned char         cout_mux_cntrl;                        	/* FLOW CONTROL 			*/   /* 0067 */
  unsigned short        cout_flow_timeout;                      /* FLOW CONTROL TIMEOUT 		*/   /* 0068 */
  unsigned short        cout_attn_enbl;                         /* OUTPUT ATTENTION ENABLE 		*/   /* 006A */
  unsigned char         cout_xoff_1;                            /* XOFF-1 CHARACTER 			*/   /* 006C */
  unsigned char         cout_xoff_2;                            /* XOFF-2 CHARACTER 			*/   /* 006D */
  unsigned char         cout_xon_1;                             /* XON-1 CHARACTER 			*/   /* 006E */
  unsigned char         cout_xon_2;                             /* XON-2 CHARACTER 			*/   /* 006F */
  unsigned char         cout_tim_scale;                         /* TIMER SCALE REGISTER 		*/   /* 0070 */
  unsigned char         cout_tim_reg;                           /* TIMER REGISTER 			*/   /* 0071 */
  unsigned char         cout_cpu_req;                           /* CPU REQUEST REGISTER 		*/   /* 0072 */
  unsigned char         cout_lck_cntrl;                         /* OUTPUT LOCKP AND CONTROL REG 	*/   /* 0073 */
  unsigned char         cout_ses_col_d;                         /* SESSION COLUMN COUNTER  		*/   /* 0074 */
  unsigned char         cout_ses_cntrl_d;                       /* SESSION CONTROL REGISTER 		*/   /* 0075 */
  unsigned short	cout_ses_char_ctr_d ;			/* SESSION CHARACTER COUNTER		*/   /* 0076 */
  unsigned int		output_undefined_12;            	/* UNDEFINED DWORD 			*/   /* 0078 */
  unsigned int		output_undefined_13;            	/* UNDEFINED DWORD 			*/   /* 007E */

};      /* END STRUCT DEFINING ICPS O/P REGISTERS */							     /* 0080 */





/*#stitle Output Queue Command OP Codes #*/
/*#page*/
/******************************************************************************/
/*                                                                            */
/*                      OUTPUT QUEUE COMMAND OP CODES                         */
/*                                                                            */
/******************************************************************************/

/*
 ;                       OP CODE                     COMMAND
 ;                       -------         -------------------------------
*/

#define CMMD_HALT               0x000          /* HALT				*/
#define CMMD_QMRK               0x001          /* SET QMARKER EVENT		*/
#define CMMD_BRK_END            0x002          /* END BREAK			*/
#define CMMD_BRK_START          0x003          /* START BREAK			*/
#define CMMD_SEQ_END            0x004          /* END UNBREAKABLE S ENCE	*/
#define CMMD_SEQ_START          0x005          /* START UNBREAKABLE S ENCE	*/
#define CMMD_OPOST_END          0x006          /* DISABLE OUTPUT POST PROCESSING*/
#define CMMD_OPOST_START        0x007          /* ENABLE OUTPUT POST PROCESSING	*/
#define CMMD_SESS_SEL           0x008          /* SELECT SESSION REG		*/
#define CMMD_PAUSE              0x009          /* PAUSE				*/
#define CMMD_SET_DATA_PTR       0x00A          /* SET DATA POINTER		*/
#define CMMD_SEND_DATA          0x00B          /* SET DATA COUNT & SEND DATA	*/

#define CMMD_IMED_DATA_1        0x02C          /* SEND 1 BYTE  OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_2        0x03C          /* SEND 2 BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_3        0x04C          /* SEND 3 BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_4        0x05C          /* SEND 4 BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_5        0x06C          /* SEND 5 BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_6        0x07C          /* SEND 6 BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_7        0x08C          /* SEND 7 BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_8        0x09C          /* SEND 8 BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_9        0x0AC          /* SEND 9 BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_A        0x0BC          /* SEND A BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_B        0x0CC          /* SEND B BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_C        0x0DC          /* SEND C BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_D        0x0EC          /* SEND D BYTES OF IMMEDIATE DATA*/
#define CMMD_IMED_DATA_E        0x0FC          /* SEND E BYTES OF IMMEDIATE DATA*/

#define CMMD_SWTCH_Q            0x00D          /* SWITCH QUEUE			*/
#define CMMD_NOP                0x00F          /* NOP				*/

