/*****************************************************************************/
/*      EQUINOX SuperSerial Technology (SST) Driver for Linux                */
/*                                                                           */
/*      Copyright (C) 1989-2002 Equinox Systems Inc.                         */
/*****************************************************************************/   

/* --------------CSTREAM package header package ------------------ */
#define SENOMEM 1001
#define SEINVAL 1002
#define BUFSIZE 8192


typedef struct	{
	struct termios sterm; /* save termio struct */
	struct termios cterm; /* clobber termio */
	unsigned int xm; /* transfer xmit count*/
	unsigned int rc; /* transfer recieve count*/
	unsigned int err; /* error count*/
	int fd;		/* file descripter */
	char dir;	/* direction: r or w */
	int total;	/* total chars in buf */
	int next;	/* next char in buf */
	unsigned char patt;
	int pnum;	/* port number */
#ifdef CHRDRVR
	unsigned char buf[BUFSIZE];	/* buffer */
#else
    /* unsigned char buf[BUFSIZE / 2 ]; buffer smaller for STREAMS; mostly */
    unsigned char buf[BUFSIZE]; /* buffer smaller for STREAMS; mostly */
 									/* done for tuning. STREAMS elastictiy */
   									/* tends to cause large reads */
#endif
	char fname[35];
	int highbaud;
	int loopback;
}CSTREAM;
typedef struct {
	int fd[2];
}CPIPE;

CSTREAM *Sopen(char *path, char *dir); /* -- open stream -- */
int Sgets();
int Sgetc();
int  Sclose(CSTREAM *z);	/* -- close a stream -- */
int Sputc( CSTREAM *z, unsigned char c);

