/*****************************************************************************/
/*      EQUINOX SuperSerial Technology (SST) Driver for Linux                */
/*                                                                           */
/*      Copyright (C) 1989-2002 Equinox Systems Inc.                         */
/*****************************************************************************/   

/* ------------------ char arrays for regs ---------------- */

#define IDXMSK	0xFFF
#define STS	mpstat.mp_icpchan

/* board ID's */
#define SS64_I	0x08
#define SS128_I 0x10
#define SS8_I	0x18
#define SS4_I	0x20
#define SSP2_I	0xF0
#define SSP4_I	0xF8
#define SSP4_I_R1	0xF9
#define SSP8_I_R1	0x1B
#define SSP8_E_R1	0xFA
/* 2 control signals boards */
#define SSM_24_I	0x38
#define SSM_12_I	0x30
#define SSP8M_I_R1	0x2D

/* hack to match .h files */
#ifndef	BUS_ISA
#define	BUS_ISA	1
#endif
#ifndef	BUS_EISA
#define BUS_EISA	2
#endif
#ifndef	BUS_MCA
#define	BUS_MCA		3
#endif

#ifndef	DEV_GOOD
#define DEV_GOOD	1
#endif
#ifndef DEV_BAD
#define DEV_BAD		0
#endif
#ifndef	DEV_VIRGIN	
#define	DEV_VIRGIN	-1
#endif


/* product names */
char P_SS2IC[] = "SST-2P";  /* SSP-LMX combo */
char P_SS2EC[] = "SSTE-2I";  /* SSP-LMX combo */
char P_SS4PC[] = "SST-4P";
char P_SS4IC[] = "SST-4I";
char P_SS8PC[] = "SST-8P";
char P_SS8IC[] = "SST-8I";
char P_SS8IM[] = "SST-8M";
char P_SS4EC[] = "SSTC-4E"; /* SSP-LMX combo */
char P_SS8EC[] = "SSTC-8E"; /* SSP-LMX combo */

/* New in 3.30 */
char P_SS8IRJ[] = "SST-8I/RJ";
char P_SS4IRJ[] = "SST-4I/RJ";
char P_SS16P[] = "SST-16P";
char P_SS16PDB[] = "SST-16P CP16-DB";
char P_SS16PRJ[] = "SST-16P CP16-RJ";
char P_SS16PNO[] = "SST-16P No panel";
char P_SS16I[] = "SST-16I";
char P_SS16IDB[] = "SST-16I CP16-DB";
char P_SS16IRJ[] = "SST-16I CP16-RJ";
char P_SS16INO[] = "SST-16I No panel";
/* End 3.30 */

char P_SS16PDB9[] = "SST-16P CP16-DB9";
char P_SS4LP[] = "SST-4P/LP";
char P_SS4ULP[] = "SST-4P/ULP";

char P_MM8P[] = "SST-MM8P";
char P_MM4P[] = "SST-MM4P";

char P_SS8PRJ[] = "SST-8P/RJ";
char P_SS4PRJ[] = "SST-4P/RJ";

char P_SS4IPWR[] = "SST-4I,PWR";
char P_SS8IPWR[] = "SST-8I,PWR";
char P_SS4PPWR[] = "SST-4P,PWR";
char P_SS8PPWR[] = "SST-8P,PWR";

char P_SS2I[] = "SST-2I";
char P_SS4I[] = "SST-4I";
char P_SS4M[] = "SST-4M";
char P_SS4E[] = "SST-4E";

char P_SSP4M_GDC[] = "SST-MPM4";

char P_SS8I[] = "SST-8I";
char P_SS8M[] = "SST-8M";
char P_SS8E[] = "SST-8E";

char P_SS8E_422[] = "SST-8E/422";

char P_SS64I[] = "SST-64I";
char P_SS64M[] = "SST-64M";
char P_SS64E[] = "SST-64E";

char P_SS128I[] = "SST-128I";
char P_SS128M[] = "SST-128M";
char P_SS128E[] = "SST-128E";

char P_SSM_24I[] = "SSM-24I";
char P_SSM_24M[] = "SSM-24M";
char P_SSM_24E[] = "SSM-24E";

char P_SSM_8I[] = "SSM-8I";
char P_SSM_12I[] = "SSM-12I";
char P_SSM_12M[] = "SSM-12M";
char P_SSM_12E[] = "SSM-12E";

char P_SS64P[] = "SST-64P";  /* SST64 based PCI 64 port board */
char P_SS128P[] = "SST-128P"; /* SST64 based PCI 128 port board */

char P_UNKNOWN[] = "Unknown";
struct strdisp {
	char	sp_state[5];
	char	sp_iflag[5];
	char	sp_oflag[5];
	char	sp_lflag[5];
	char	sp_cflag[5];
	char	sp_flags[5];
	char	sp_dev[5];
	char	sp_rawqcc[5];
	char	sp_outqcc[5];
	char	sp_delct[5];
	char	sp_param[5];
	char	sp_txbase[5];
	char	sp_rxbase[5];
	char	sp_rxcs[5];
	char	sp_txcs[5];
	char	sp_txidx[5];
	char	sp_txend[5];
	char	sp_rxidx[5];
	char	sp_rxend[5];
	char	sp_rxbaud[5];
	char	sp_txbaud[5];
	char	sp_modem[5];
	char	sp_dtr[5];
	char	sp_txcsr[5];
	char 	sp_rxcsr[5];
	char	sp_cie[5];
	char	sp_cis[5];
	char	sp_sample[5];
	char	sp_mie[5];
	char	sp_rxtdm[5];
	char	sp_txtdm[5];
	char	sp_page[5];
	char	sp_ldisp[5];
	char	sp_rmode[5];
	char	sp_wmode[5];
	char	sp_start[5];
	char	sp_stop[5];
	char	sp_esctim[5];
	char	sp_htky1[5];
	char	sp_htky2[5];
	char	sp_add16[5];
	char	sp_type16[5];
	char	sp_selbus[5];
	char	sp_linkst[5];
	char	sp_linkno[5];
	char	sp_cmxtyp[5];
	char	sp_cmxid[5];
	char	sp_sync[5];
	char	sp_equlz[5];
	char	sp_eqmin[5];
	char	sp_eqmax[5];
	char	sp_output[15];
	char	sp_input[15];
};

struct btypes {
	int	type;
	int bsize;
	int csize;
	char *desc;
	char *pnum;
};
struct btypes at_brds [] = {
	{ 3, 8, 8, "MEGAPORT 24CS", "950083" },
	{ 5, 64, 8, "MEGAPORT 24CS", "950083-2" },
	{ 6, 64, 8, "MEGAPORT 12CS", "950101-1" },
	{ 7, 64, 8, "MEGAPORT 12CS", "950101-2" },
	{ 9, 64, 8, "MEGAPORT 12LD", "950110" },
	{ 16, 8, 8, "MEGAPORT 24CS", "950149" },
	{ 17, 8, 8, "MEGAPORT 12CS", "950148" },
	{ 18, 8, 8, "MEGAPORT 12LD", "950167" },
	{ 19, 8, 8, "MEGAPORT 24LD", "950164" },
	{ 22, 8, 8, "MEGAPORT 8CS", "950147" },
	{ 23, 8, 8, "MEGAPORT 12FMC", "" },
	{ 24, 8, 8, "MEGAPORT XP", "" },
	{ 64, 8, 8, "MEGAPLEX 96", "950134" },
	{ 0,	0,	0, NULL, NULL },
};
struct btypes mca_brds [] = {
	{ 0, 8, 8, "MEGAPORT/2 24CS", "950180" },
	{ 1, 8, 8, "MEGAPORT/2 12CS", "950179" },
	{ 2, 8, 8, "MEGAPORT/2 24LD", "950182" },
	{ 3, 8, 8, "MEGAPORT/2 12LD", "950181" },
	{ 4, 8, 8, "MEGAPORT/2 12LD+12CS", "950183" },
	{ 5, 8, 8, "MEGAPORT/2 12FMC", "" },
	{ 6, 8, 8, "MEGAPORT/2 XP", "" },
	{ 64, 8, 8, "MEGAPLEX 96", "950184" },
	{ 0,	0,	0, NULL, NULL },
};
static struct tio_flags {
	char *fname;
	int val; 
} t_iflag [] = {
	{ "IGNBRK",  0000001 },  /* Ignores break condition */
	{ "BRKINT",  0000002 },  /* Signals interrupt on break */
	{ "IGNPAR",  0000004 },  /* Ignores characters with parity errors */
        { "PARMRK",  0000010 },  /* Marks parity errors */
        { "INPCK",   0000020 },  /* Enables input parity check */
        { "ISTRIP",  0000040 },  /* Strips character */
        { "INLCR",   0000100 },  /* Maps NL to CR on input */
        { "IGNCR",   0000200 },  /* Ignores CR */
        { "ICRNL",   0000400 },  /* Maps CR to NL on input */
	{ "IUCLC",   0001000 },  /* Maps uppercase to lowercase on input */
        { "IXON",    0002000 },  /* Enables start/stop output control */
        { "IXANY",   0004000 },  /* Enables any character to restart output */
        { "IXOFF",   0010000 },  /* Enables start/stop input control */
	{ "IMAXBEL", 0020000 },  
	{ NULL,      0 },
};
struct tio_flags t_oflag [] = {
        { "OPOST",   0000001 },  /* Postprocesses output */
        { "OLCUC",   0000002 },  /* Maps lowercase to uppercase on output */
        { "ONLCR",   0000004 },  /* Maps NL to CR-NL on output */
        { "OCRNL",   0000010 },  /* Maps CR to NL on output */
        { "ONOCR",   0000020 },  /* No CR output at column 0 */
        { "ONLRET",  0000040 },  /* NL performs CR function */
        { "OFILL",   0000100 },  /* Uses fill characters for delay */
        { "OFDEL",   0000200 },  /* Fills is DEL, else NUL */
        { "NLDLY",   0000400 },  /* Selects newline delays: */
        { "CRDLY",   0003000 },  /* Selects carriage return delays: */
        { "CR1",     0001000 },
        { "CR2",     0002000 },
        { "CR3",     0003000 },
        { "TAB1",    0004000 },
        { "TAB2",    0010000 },
        { "TAB3",    0014000 },  /* Expands tabs to spaces */
        { "BSDLY",   0020000 },  /* Selects backspace delays: */
        { "VTDLY",   0040000 },  /* Selects vertical tab delays: */
        { "FFDLY",   0100000 },  /* Selects form feed delays: */
	{ NULL,	0 },
};
struct tio_flags t_cflag [] = {
        { "CSTOPB",  0000100 },  /* Sends two stop bits, else one */
        { "CREAD",   0000200 },  /* Enables receiver */
        { "PARENB",  0000400 },  /* Parity enable */
        { "PARODD",  0001000 },  /* Odd parity, else even */
        { "HUPCL",   0002000 },  /* Hangs up on last close */
        { "CLOCAL",  0004000 },  /* Local line, else dial-up */
        { "CBAUDEX", 0010000 },  /* Block layer output */
        { "RTSCTS", 020000000000 },  /* Enables RTS/CTS protocol 
					for a modem line */
	{ NULL,	0 },
};
struct tio_flags t_lflag [] = {
        { "ISIG",    0000001 },  /* Enable signals */
        { "ICANON",  0000002 },  /* Canonical input (erase and kill processing)*/ 
        { "XCASE",   0000004 },  /* Canonical upper/lower presentation */
        { "ECHO",    0000010 },  /* Enables echo */
        { "ECHOE",   0000020 },  /* Echoes erase character as BS-SP-BS */
        { "ECHOK",   0000040 },  /* Echoes NL after kill character */
        { "ECHONL",  0000100 },  /* Echoes NL */
        { "NOFLSH",  0000200 },  /* Disables flush after interrupt or quit */
          /*"XCLUDE",  0100000,*/  /* Exclusive use of the line */
	{ NULL, 0 },
};
#ifndef	CHRDRVR
struct eqn_private_flags {
	char *fname;
	unsigned int val; 
} mpcflags [] = {
	"MPC_FLUSHIN ",	MPC_FLUSHIN,	/* flush input on next poll */
	"MPC_OUTCS_UP ",MPC_OUTCS_UP,	/* outbound contrl sigs raised  */
	"MPC_TXQBUSY ",	MPC_TXQBUSY,	/* set by eqnoput */
	"MPC_V24CFG ",	MPC_V24CFG,	/* v24 processing configured */
	"MPC_LPCFG ",	MPC_LPCFG,	/* slave printer configured */
	"MPC_OPEN ",	MPC_OPEN,	/* channel open */
	"MPC_LPOPEN ",	MPC_LPOPEN,	/* slave printer open */
	"MPC_LOOPBACK ",MPC_LOOPBACK,	/* channel in loopback mode */
	"MPC_BLOCK ",	MPC_BLOCK,	/* input flow controlled */
	"MPC_FLUSHOUT ",MPC_FLUSHOUT,	/* close flush output */
	"MPC_IXON ",	MPC_IXON,	/* dont honor -IXON */
	"MPC_IXANY ",	MPC_IXANY,	/* dont honor IXANY */
	"MPC_CDON",	MPC_CDON,	/* force CLOCAL processing*/
	"MPC_RXQBUSY ",	MPC_RXQBUSY,	/* force input char event */
	"MPC_HIGHBAUD ",MPC_HIGHBAUD,	/* alternate baudrate interpret */
	"MPC_FLOWOFF ",	MPC_FLOWOFF,	/* software flag following STOPDMA */
	"MPC_LPBUSY ",	MPC_LPBUSY,	/* lp output on - delays close */
	"MPC_VCLOSE ",	MPC_VCLOSE,	/* vpix close inprogress */
	"MPC_HANGUP",	MPC_HANGUP,	/* vpix close inprogress */
	"MPC_FLOWCHG",	MPC_FLOWCHG,	/* flow control modified force flow on*/
	NULL,		0,
};
#endif
